import socket
import threading
import config as cfg
from .worker import Worker
from nacl.public import PrivateKey

def new_x25519():
    private_key = PrivateKey.generate()
    key_exchange = bytes(private_key.public_key)
    return bytes(private_key).hex() , key_exchange.hex()

class Cryptor(Worker):

    def __init__(self, parent):
        super().__init__(self,parent)
        self.privatekey , self.key_exchange = new_x25519()
        print("\n\n CRYPTOR,  \n ",self.privatekey ,type (self.key_exchange),"\n")

    
    def socketOracle(self,HOST,PORT):
        self.connector = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.connector.connect((HOST, PORT))
        t = threading.Thread(target=self.receive)
        t.start()
        self.toSEND({
            "type":"oracleInit",
            "oracle":"Cryptor"
        })
        print("socket is created and Listener is created\n")
        self.toSEND({
            "type":"key_exchange",
            "key_exchange":self.key_exchange
        })


    def start(self,a):
        print("Cryptor",a)
        self.socketOracle(self.connectorIP,self.connectorPort)